#include <assert.h>
#include <stdio.h>

__global__ void addKernel( int a, int b, int *c ) {
    *c = a + b;
}

int main( void ) {
    int host_a; //host (CPU)
    int *device_a; //device (GPU)
    const int A_BYTES = 1 * sizeof(int);

    //Reservamos memoria en el GPU
    cudaMalloc( (void**)&device_a, A_BYTES );

    //Llamada al kernel
    addKernel<<<1,1>>>( 7, 6, device_a );

    //Copia memoria del Device al Host
    //cudaMemcpy(direccion_destino, direccion_fuente, de_dónde_a_dónde);
    cudaMemcpy( &host_a, device_a, sizeof(int), cudaMemcpyDeviceToHost );
    
    //Comprobamos resultado
    assert( 7 + 6 == host_a);   
    printf("\n (: Ejecucion correcta :) \n");

    //Libera memoria del device
    cudaFree( device_a );

    return 0;
}
