#include <assert.h>
#include <stdio.h>
#include "Error.h"

int var_1 = 1;
__device__ int var_2 = 0;

// 1. quitar __global__
__global__ void addKernel( int a, int b, int *c ) {
    *c = a + b;
// 3. variable var_1 no puede ser modificada en el kernel
    //var_1 = a + b;
    var_2 = a + b;
    
// 5. no se puede leer la variale var_1 en el kernel    
    //var_2 = (a + b) * var_1;
}

int main( void ) {
    int h_c;
    int *d_c;
    int h_var_1;
    const int C_BYTES = 1 * sizeof(int);

    HANDLER_ERROR_ERR(cudaMalloc( (void**)&d_c, C_BYTES ));

// 2. cambiar la configuración de la ejecución    
    addKernel<<<1,1>>>( 6, 7, d_c );
    HANDLER_ERROR_MSG( "Kernel Panic!!!" );
    cudaDeviceSynchronize();

    HANDLER_ERROR_ERR(cudaMemcpy( &h_c, d_c, C_BYTES, cudaMemcpyDeviceToHost ));   
    HANDLER_ERROR_ERR(cudaMemcpy( &h_var_1, d_c, C_BYTES, cudaMemcpyDeviceToHost ));
 
    assert( 6 + 7 == h_c);  
    assert( 6 + 7 == h_var_1);  

// 4. la variable var_2 puede ser modificada, pero se recibe una advertencia
    //var_2 = 4;
    //printf("%i\n", var_2);

    printf("\n (: Ejecucion correcta :) \n");

    HANDLER_ERROR_ERR(cudaFree( d_c ));

    return 0;
}
